var post;
metaEdit = new Object();
blogEdit = new Object();

const editbundle = document.getElementById("editbundle");

// This section is very inefficient, but I was short of time when writing it. It will be cleaned up in subsequent versions.

function InitEditing() {
	dsMidas.dontautoformat = false;
	document.getElementById("cmd_logout").setAttribute("disabled", true);
	document.getElementById("postbutton").collapsed = true;
	document.getElementById("deletebutton").collapsed = false;
	document.getElementById("savebutton").collapsed = false;
	document.getElementById("activeblog").collapsed = true;
	if (usemeta) {
		post = metaWeblog.posthistory.httpreq.response[0][itemid];
		document.title = editbundle.getString("EditingPost") + " " + post["postid"] + "/" + metaWeblog.blogs[0][0]["blogName"];
		var categories = post["categories"];
		var catsnode = document.getElementById("categories"); 
		if (categories.length > 1) {
			catsnode.selectedIndex = catsnode.firstChild.childNodes.length - 1;
			catsnode.selectedItem.setAttribute("value", categories.join(","));
		} else {
			for (i = 0; i < metaWeblog.categories[0].length; i++) {
				if (metaWeblog.categories[0][i]["description"] == categories[0]) {
					catsnode.selectedIndex = i;
					break;
				}
			}
		}
		if (post["title"]) {
			document.getElementById("subject").value = post["title"];
		}
		document.getElementById("messagesource").value = post["description"];
		document.getElementById("message").contentDocument.designMode = "On";
		document.getElementById("message").contentDocument.execCommand("useCSS", false, !dsPrefs.getBoolPref("UseCSS"));
		dsMidas.syncNormalTab();
	} else {
		post = blogger.posthistory.httpreq.response[0][itemid];
		document.getElementById("savebutton").setAttribute("disabled", "true");
		document.getElementById("maindisabler").setAttribute("disabled", true);
		document.getElementById("activeblog").collapsed = true;
		document.getElementById("progressbar").mode = "undetermined";
		document.getElementById("statuslabel").value = editbundle.getString("Loading");
		document.getElementById("statuswhat").value = editbundle.getString("LoadingEntry");
		document.getElementById("messagedeck").selectedIndex = 1;
		document.title = editbundle.getString("EditingIn") + " " + blogger.active;
		var params = [];
		var loginstruct = new Object();
		loginstruct["username"] = blogger.username;
		loginstruct["password"] = blogger.password;
		loginstruct["appkey"] = "0123456789ABCDEF";
		params.push(loginstruct);
		var postinfo = new Object();
		postinfo["blogID"] = blogger.active;
		postinfo["postID"] = post["postid"];
		params.push(postinfo);
		var loadpost = makeXMLRpcCall("blogger2.getPost", params);
		blogEdit.httpreq = new XMLHttpRequest();
		blogEdit.httpreq.onload = blogEdit.loadHandler;
		blogEdit.httpreq.onerror = function() {
			alert(editbundle.getString("ErrorConnecting"));
			dsPosts.sendPost();
		}
		blogEdit.httpreq.open("POST", blogger.posturl, true);
		blogEdit.httpreq.send(loadpost);
	}
}

blogEdit.loadHandler = function() {
	try {
		var response = parseXMLRpcResponse(blogEdit.httpreq.responseXML);
		if ((response["faultCode"]) || (response["faultString"])) {
			alert(editbundle.getString("ErrorLoading") + " " + response["faultString"]);
			window.close();
		} else {
			if (response[0]["title"]) {
				document.getElementById("subject").value = response[0]["title"];
			}
			document.getElementById("messagesource").value = response[0]["body"];
			document.getElementById("draftcheck").checked = response[0]["postParams"]["draft"];
			document.getElementById("message").contentDocument.designMode = "On";
			document.getElementById("message").contentDocument.execCommand("useCSS", false, !dsPrefs.getBoolPref("UseCSS"));
			dsMidas.syncNormalTab();
			
			document.getElementById("maindisabler").removeAttribute("disabled");
			document.getElementById("savebutton").removeAttribute("disabled");
			document.getElementById("messagedeck").selectedIndex = 0;
		}
	} catch (e) {
		alert(e);
		window.close();
	}
}

dsPosts.saveEdit = function() {
	if (usemeta) {
		metaEdit.saveEdit();
	} else {
		blogEdit.saveEdit();
	}
}

dsPosts.deletePost = function() {
	if (usemeta) {
		metaEdit.deletePost();
	} else {
		blogEdit.deletePost();
	}
}

// metaWeblog-specific stuff.

metaEdit.deletePost = function() {
	if (metaEdit.posting) {
		metaEdit.posting = false;
		metaEdit.httpreq.abort();
		document.getElementById("maindisabler").removeAttribute("disabled");
		document.getElementById("messagedeck").selectedIndex = 0;
		document.getElementById("savebutton").label = editbundle.getString("Save");
	} else {
		if (confirm(editbundle.getString("SureToDelete"))) {
			metaEdit.posting = true;
			document.getElementById("savebutton").label = editbundle.getString("Cancel");
			document.getElementById("maindisabler").setAttribute("disabled", true);
			document.getElementById("statuslabel").value = editbundle.getString("Deleting");
			document.getElementById("statuswhat").value = editbundle.getString("DeletingFromServer");
			document.getElementById("progressbar").mode = "undetermined";
			document.getElementById("messagedeck").selectedIndex = 1;
			
			var params = [];
			params.push("0123456789ABCDEF");
			params.push(post["postid"]);
			params.push(metaWeblog.username);
			params.push(metaWeblog.password);
			params.push(true);
			
			var deletepost = makeXMLRpcCall("blogger.deletePost", params);
			
			metaEdit.httpreq = new XMLHttpRequest();
			metaEdit.httpreq.onload = metaEdit.editHandler;
			metaEdit.httpreq.onerror = function() {
				alert(editbundle.getString("ErrorConnecting"));
				metaEdit.deletePost();
			}
			metaEdit.httpreq.open("POST", metaWeblog.posturl, true);
			metaEdit.httpreq.send(deletepost);
		}
	}
}

metaEdit.editHandler = function() {
	try {
		var response = parseXMLRpcResponse(metaEdit.httpreq.responseXML);
		dump(metaWeblog.httpreq.responseText);
		if ((response["faultCode"]) || (response["faultString"])) {
			alert(editbundle.getString("ErrorSaving") + " " + response["faultString"]);
			metaEdit.deletePost();
		} else {
			var windowmanager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
			var history = windowmanager.getMostRecentWindow("deepestsender:history");
			if (history) {
				history.setTimeout("LoadPostHistory();", 1);
			}
			setTimeout("window.close();", 1);
		}
	} catch (e) {
		alert(e);
		metaEdit.deletePost();
	}
}

metaEdit.saveEdit = function() {
	if (metaEdit.posting) {
		metaEdit.posting = false;
		metaEdit.httpreq.abort();
		document.getElementById("maindisabler").removeAttribute("disabled");
		document.getElementById("messagedeck").selectedIndex = 0;
		document.getElementById("savebutton").label = editbundle.getString("Save");
	} else {
		dsMidas.updateSourceTab();
		metaEdit.posting = true;
		document.getElementById("savebutton").label = editbundle.getString("Cancel");
		document.getElementById("maindisabler").setAttribute("disabled", true);
		document.getElementById("statuslabel").value = editbundle.getString("Saving");
		document.getElementById("statuswhat").value = editbundle.getString("SavingToServer");
		document.getElementById("progressbar").mode = "undetermined";
		document.getElementById("messagedeck").selectedIndex = 1;
		
		var params = [];
		params.push(post["postid"]);
		params.push(metaWeblog.username);
		params.push(metaWeblog.password);
		params.push(post);
		delete params[3]["postid"];
		var subjectbox = document.getElementById("subject");
		if (subjectbox.value.trim().length > 0) {
			params[3]["title"] = subjectbox.value;
		}
		params[3]["description"] = document.getElementById("messagesource").value;
		params[3]["categories"] = []
		var cats = document.getElementById("categories").selectedItem;
		catarr = cats.getAttribute("value").split(",");
		for (i = 0; i < catarr.length; i++) {
			params[3]["categories"].push(catarr[i]);
		}
		delete params[3]["dateCreated"];
		params.push(!document.getElementById("draftcheck").checked);
		
		var blogpost = makeXMLRpcCall("metaWeblog.editPost", params);
		metaEdit.httpreq = new XMLHttpRequest();
		metaEdit.httpreq.onload = metaEdit.editHandler;
		metaEdit.httpreq.onerror = function() {
			alert(editbundle.getString("ErrorConnecting"));
			metaEdit.saveEdit();
		}
		metaEdit.httpreq.open("POST", metaWeblog.posturl, true);
		metaEdit.httpreq.send(blogpost);
	}
}

// Blogger-specific stuff.

blogEdit.deletePost = function() {
	if (blogEdit.posting) {
		blogEdit.posting = false;
		blogEdit.httpreq.abort();
		document.getElementById("maindisabler").removeAttribute("disabled");
		document.getElementById("messagedeck").selectedIndex = 0;
		document.getElementById("savebutton").label = editbundle.getString("Save");
	} else {
		if (confirm(editbundle.getString("SureToDelete"))) {
			blogEdit.posting = true;
			document.getElementById("savebutton").label = editbundle.getString("Cancel");
			document.getElementById("maindisabler").setAttribute("disabled", true);
			document.getElementById("statuslabel").value = editbundle.getString("Deleting");
			document.getElementById("statuswhat").value = editbundle.getString("DeletingFromServer");
			document.getElementById("progressbar").mode = "undetermined";
			document.getElementById("messagedeck").selectedIndex = 1;
			
			var params = [];
			params.push("0123456789ABCDEF");
			params.push(post["postid"]);
			params.push(blogger.username);
			params.push(blogger.password);
			params.push(true);
			
			var deletepost = makeXMLRpcCall("blogger.deletePost", params);
			
			blogEdit.httpreq = new XMLHttpRequest();
			blogEdit.httpreq.onload = blogEdit.editHandler;
			blogEdit.httpreq.onerror = function() {
				alert(editbundle.getString("ErrorConnecting"));
				blogEdit.deletePost();
			}
			blogEdit.httpreq.open("POST", blogger.posturl, true);
			blogEdit.httpreq.send(deletepost);
		}
	}
}

blogEdit.editHandler = function() {
	try {
		var response = parseXMLRpcResponse(blogEdit.httpreq.responseXML);

		if ((response["faultCode"]) || (response["faultString"])) {
			alert(editbundle.getString("ErrorSaving") + " " + response["faultString"]);
			blogEdit.deletePost();
		} else {
			var windowmanager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
			var history = windowmanager.getMostRecentWindow("deepestsender:history");
			if (history) {
				history.setTimeout("LoadPostHistory();", 1);
			}
			setTimeout("window.close();", 1);
		}
	} catch (e) {
		alert(e);
		blogEdit.deletePost();
	}
}

blogEdit.saveEdit = function() {
	if (blogEdit.posting) {
		blogEdit.posting = false;
		blogEdit.httpreq.abort();
		document.getElementById("maindisabler").removeAttribute("disabled");
		document.getElementById("messagedeck").selectedIndex = 0;
		document.getElementById("savebutton").label = editbundle.getString("Save");
	} else {
		dsMidas.updateSourceTab();
		blogEdit.posting = true;
		document.getElementById("savebutton").label = editbundle.getString("Cancel");
		document.getElementById("maindisabler").setAttribute("disabled", true);
		document.getElementById("statuslabel").value = editbundle.getString("Saving");
		document.getElementById("statuswhat").value = editbundle.getString("SavingToServer");
		document.getElementById("progressbar").mode = "undetermined";
		document.getElementById("messagedeck").selectedIndex = 1;
		
		var params = [];
		var loginstruct = new Object();
		loginstruct["username"] = blogger.username;
		loginstruct["password"] = blogger.password;
		loginstruct["appkey"] = "0123456789ABCDEF";
		params.push(loginstruct);

		var poststruct = new Object();
		poststruct["body"] = document.getElementById("messagesource").value; 
				
		var subjectbox = document.getElementById("subject");
		poststruct["title"] = subjectbox.value;
		poststruct["blogID"] = blogger.active;
		poststruct["postID"] = post["postid"];
		params.push(poststruct);

		var actions = new Object();
		actions["doPublish"] = true;
		actions["makeDraft"] = !document.getElementById("draftcheck").checked;
		params.push(actions);
		
		var blogpost = makeXMLRpcCall("blogger2.editPost", params);
		blogEdit.httpreq = new XMLHttpRequest();
		blogEdit.httpreq.onload = blogEdit.editHandler;
		blogEdit.httpreq.onerror = function() {
			alert(editbundle.getString("ErrorConnecting"));
			blogEdit.saveEdit();
		}
		blogEdit.httpreq.open("POST", blogger.posturl, true);
		blogEdit.httpreq.send(blogpost);
	}
}
